import React from 'react';
import ReactDOM from 'react-dom';
import TestUtils from 'react-addons-test-utils';
import purebem from 'purebem';

import RouteButton from './RouteButton';

import AnchorTestWrapper from '../../test-utils/AnchorTestWrapper';


const TestRouteButton = RouteButton({
    block: purebem.of('test-button'),
    displayName: 'TestRouteButton'
});

describe('RouteButton', () => {

    it('should not navigate when disabled', () => {
        const wrapper = TestUtils.renderIntoDocument(
            <AnchorTestWrapper>
                <TestRouteButton disabled={ true } />
            </AnchorTestWrapper>
        );

        const button = TestUtils.findRenderedComponentWithType(wrapper, TestRouteButton);
        const node = ReactDOM.findDOMNode(button);

        TestUtils.Simulate.click(node);

        expect(wrapper.didNavigate).toBeFalsy();
    });

});
