import test from 'tape';
import Immutable from 'seamless-immutable';

import mount, { reducer, type } from './mount';


test('should mount state', (t) => {
    const root = 'test';

    const action = mount({ initialComponentState: { my: 'state' }, root });
    const state = reducer[type](Immutable({}), action);

    t.same(state, { [root]: { my: 'state' } });
    t.end();
});

test('should not re-mount state', (t) => {
    const root = 'test';

    const action = mount({ initialComponentState: { my: 'state' }, root });
    const state = reducer[type](Immutable({}), action);

    const raction = mount({ initialComponentState: { my: 'new-state' }, root });
    const rstate = reducer[type](state, raction);

    t.same(rstate, { [root]: { my: 'state' } });
    t.end();
});
