import handleFoundationAction from '../../../utils/handleFoundationAction';


const foundation = 'dropdown.expand';

export default ({ path, root, type }) => {
    return {
        type,
        meta: {
            foundation,
            path,
            root
        },
        payload: {
            expanded: true
        }
    };
};

export const reducer = handleFoundationAction(foundation, (action) => (obj) => {
    const options = obj.options.filter((option) => obj.value === option.value);
    const highlightedIndex = options.length > 0 ? obj.options.indexOf(options[0]) : -1;

    return {
        ...obj,
        ...action.payload,
        highlightedIndex
    };
});
