const isAboveVisible = (nodeHeight, height, options) => {
    return (height + nodeHeight) > (options.scrollTop + options.clientHeight);
};

const isBelowVisible = (height, options) => {
    return height < options.scrollTop;
};

const isMovingFromBottomToTop = (previousHighlightedIndex, highlightedIndex, options) => {
    return previousHighlightedIndex === (options.length - 1) && highlightedIndex === 0;
};

const isMovingFromNoneToTop = (previousHighlightedIndex, highlightedIndex) => {
    return previousHighlightedIndex === -1 && highlightedIndex === 0;
};

const isMovingFromTopToBottom = (previousHighlightedIndex, highlightedIndex, options) => {
    return highlightedIndex === (options.length - 1) && previousHighlightedIndex === 0;
};

const isMovingFromNoneToBottom = (previousHighlightedIndex, highlightedIndex, options) => {
    return previousHighlightedIndex === -1 && highlightedIndex === (options.length - 1);
};

export default (previousHighlightedIndex, highlightedIndex, isFind, options, components, getComponentHeight) => {
    const height = options.slice(0, highlightedIndex)
        .map((option) => {
            const index = options.indexOf(option);
            return getComponentHeight(index);
        })
        .reduce((prev, curr) => {
            return prev + curr;
        }, 0);

    const nodeHeight = getComponentHeight(highlightedIndex);

    if (isFind) {
        return height - (components.options.clientHeight / 2) + (nodeHeight / 2);
    }

    if (isMovingFromBottomToTop(previousHighlightedIndex, highlightedIndex, options) || isMovingFromNoneToTop(previousHighlightedIndex, highlightedIndex)) {
        return 0;
    }

    if (isMovingFromTopToBottom(previousHighlightedIndex, highlightedIndex, options) || isMovingFromNoneToBottom(previousHighlightedIndex, highlightedIndex, options)) {
        return components.options.scrollHeight;
    }

    if (isAboveVisible(nodeHeight, height, components.options)) {
        return components.options.scrollTop + nodeHeight;
    }

    if (isBelowVisible(height, components.options)) {
        return components.options.scrollTop - nodeHeight;
    }

    return components.options.scrollTop;
};
