import test from 'tape';

import textboxNumberState from './textboxNumberState';


test('should have sensible defaults', (t) => {
    const state = textboxNumberState();
    t.same(state, { focus: false, rawValue: '', value: 0 });
    t.end();
});

test('should set rawValue when setting value', (t) => {
    const state = textboxNumberState({ value: 1 });
    t.same(state, { focus: false, rawValue: '1', value: 1 });
    t.end();
});

test('should not be able to set non-numeric value', (t) => {
    const state = textboxNumberState({ value: 'a' });
    t.same(state, { focus: false, rawValue: '', value: 0 });
    t.end();
});

test('should convert numeric string value to number', (t) => {
    const state = textboxNumberState({ value: '1' });
    t.same(state, { focus: false, rawValue: '1', value: 1 });
    t.end();
});
