import Immutable from 'seamless-immutable';
import { combineReducers, createStore } from 'redux';

import componentsReducer from '../componentsReducer';


export default (defaultComponentState = []) => {
    const root = combineReducers({
        actions: (state = Immutable([]), action = {}) => {
            if (action.type === '@@redux/INIT') {
                return state;
            }

            return [...state, action];
        },
        components: componentsReducer({ defaultState: defaultComponentState })
    });

    return createStore(root);
};
